"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var use_await_dom_render_1 = require("@garage-panda/use-await-dom-render");
var common_utils_1 = require("../utils/common-utils");
var PdfExport = function (_a) {
    var containerRef = _a.containerRef, className = _a.className, _b = _a.showInDom, showInDom = _b === void 0 ? true : _b, options = _a.options, _c = _a.lazyLoad, lazyLoad = _c === void 0 ? false : _c, children = _a.children;
    var _d = use_await_dom_render_1.useAwaitDomRender(), observer = _d[0], startWait = _d[1];
    var attachObserverListener = function (mountNode, pdfContainer) {
        observer.on('load', function () {
            observer.removeListeners();
            containerRef.iframeRef.current.contentWindow.print();
            mountNode.head.innerHTML = '';
            mountNode.body.innerHTML = '';
        });
        startWait(pdfContainer);
    };
    var populateChildren = function (mountNode) {
        var pdfContainer = mountNode.createElement('div');
        mountNode.body.appendChild(pdfContainer);
        if (lazyLoad) {
            attachObserverListener(mountNode, pdfContainer);
        }
        react_dom_1.default.render(react_1.default.createElement(react_1.default.Fragment, null, children), pdfContainer);
    };
    react_1.useEffect(function () {
        if (!lazyLoad) {
            return;
        }
        var mountNode = containerRef.iframeRef.current.contentWindow.document;
        containerRef.populateRef.current = function () {
            populateChildren(mountNode);
        };
    }, [lazyLoad]);
    react_1.useEffect(function () {
        if (!containerRef.iframeRef.current) {
            return;
        }
        var _a = common_utils_1.mergeOptions(options), includeParentStyles = _a.includeParentStyles, styles = _a.styles, scripts = _a.scripts;
        var mountNode = containerRef.iframeRef.current.contentWindow.document;
        if (includeParentStyles) {
            var parentStyles = document.querySelectorAll('style');
            parentStyles.forEach(function (style) { return common_utils_1.cloneStyle(mountNode, style); });
        }
        styles.forEach(function (href) { return common_utils_1.appendStyle(mountNode, href); });
        scripts.forEach(function (src) { return common_utils_1.appendScript(mountNode, src); });
        if (!lazyLoad) {
            populateChildren(mountNode);
        }
        return function () {
            mountNode.head.innerHTML = '';
            mountNode.body.innerHTML = '';
        };
    }, [options]);
    var styles = react_1.useMemo(function () {
        if (!showInDom) {
            return {
                position: 'absolute',
                opacity: 0,
                zIndex: -10,
            };
        }
        return {};
    }, [showInDom]);
    return (react_1.default.createElement("iframe", { ref: containerRef.iframeRef, className: "" + className, style: styles }));
};
exports.default = PdfExport;
