"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
exports.default = (function () {
    var iframeRef = react_1.useRef();
    var populateRef = react_1.useRef(null);
    var generatePdf = react_1.useCallback(function () {
        if (!iframeRef.current) {
            return;
        }
        var isLazyLoad = !!populateRef.current;
        if (isLazyLoad) {
            populateRef.current();
        }
        else {
            iframeRef.current.contentWindow.print();
        }
    }, [iframeRef]);
    return {
        generatePdf: generatePdf,
        containerRef: {
            iframeRef: iframeRef,
            populateRef: populateRef,
        },
    };
});
